## spades 3.15.5+dfsg

=== assembler/src/CMakeLists.txt ===
# -*- cmake -*-
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

#project(SpadesToolkit
#        LANGUAGES C CXX)

# Hard prerequisites
cmake_minimum_required(VERSION 3.12)

# allow more human readable "if then else" constructs
set(CMAKE_ALLOW_LOOSE_LOOP_CONSTRUCTS TRUE) 

# modules to find additional libraries (like zlib, boost and etc)
# Add path for custom modules
set(CMAKE_MODULE_PATH
  ${CMAKE_MODULE_PATH}
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake"
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")
# Define various dirs
set(SPADES_MAIN_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR})
set(SPADES_MODULES_DIR ${SPADES_MAIN_SRC_DIR}/common)
set(SPADES_MAIN_INCLUDE_DIR ${SPADES_MAIN_SRC_DIR}/include)
set(SPADES_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})
set(SPADES_TOOLS_BINARY_DIR ${SPADES_BINARY_DIR}/bin)
set(SPADES_BUILT_INCLUDE_DIR ${SPADES_BINARY_DIR}/include)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${SPADES_TOOLS_BINARY_DIR})
set(EXT_DIR "${CMAKE_SOURCE_DIR}/../ext")
set(SPADES_CFG_DIR "${CMAKE_SOURCE_DIR}/../configs")

# Uncomment for gprof profiling
#SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
#SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pg")
#SET(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -pg")

# Everything option-dependent
include(options)

# Sanity check our source directory to make sure that we are not trying to
# generate an in-tree build 
if ((CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR) OR
    (CMAKE_SOURCE_DIR STREQUAL "${CMAKE_BINARY_DIR}/src"))
  message(FATAL_ERROR "In-source builds are not allowed.
Please create a directory and run cmake from there, passing the path
to this source directory as the last argument.
This process created the file `CMakeCache.txt' and the directory `CMakeFiles'.
Please delete them.")
endif()

# Handle commond deps
include(deps)

# Add flags if necessary
include(flags)

# Handle common includes
include(includes)

# Handle common libs
include(libs)

include(GetGitRevisionDescription)
get_git_head_revision(SPADES_GIT_REFSPEC SPADES_GIT_SHA1)
if ((NOT SPADES_GIT_REFSPEC) OR (SPADES_GIT_REFSPEC STREQUAL "GITDIR-NOTFOUND"))
  set(SPADES_GIT_REFSPEC "N/A")
endif()
if (NOT SPADES_GIT_SHA1)
  set(SPADES_GIT_SHA1 "N/A")
endif()

# Testing
include(test)

message("Building SPAdes from ${SPADES_GIT_REFSPEC}, sha: ${SPADES_GIT_SHA1}")

configure_file("${SPADES_MAIN_INCLUDE_DIR}/config.hpp.in"
               "${SPADES_BUILT_INCLUDE_DIR}/config.hpp")
configure_file("${SPADES_MAIN_INCLUDE_DIR}/version-gen.hpp.in"
               "${SPADES_BUILT_INCLUDE_DIR}/version-gen.hpp")

# Build external dependencies (if any)
add_subdirectory("${EXT_DIR}/src" "${Project_BINARY_DIR}/ext")

# Setup warnings
add_compile_options(-Wall -Wextra -Wconversion -Wno-sign-conversion -Wno-long-long -Wwrite-strings)
if (NOT OPENMP_FOUND)
  add_compile_options(-Wno-unknown-pragmas)
endif()

# Looking for README.md
if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/../README.md")
  #installing from archive
  set(README_MD_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../README.md")
else()
  #installing from the repo
  set(README_MD_PATH "${CMAKE_CURRENT_SOURCE_DIR}/../../README.md")
endif()

# sub projects
add_subdirectory(common)
add_subdirectory(projects)
add_subdirectory(spades_pipeline)


# Main pipeline script
install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../spades.py"
        DESTINATION bin
        COMPONENT runtime)
install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../metaspades.py"
        DESTINATION bin
        COMPONENT runtime)
install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../plasmidspades.py"
        DESTINATION bin
        COMPONENT runtime)
install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../rnaspades.py"
        DESTINATION bin
        COMPONENT runtime)
install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../metaviralspades.py"
        DESTINATION bin
        COMPONENT runtime)
install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../metaplasmidspades.py"
        DESTINATION bin
        COMPONENT runtime)
install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../rnaviralspades.py"
        DESTINATION bin
        COMPONENT runtime)      
install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../coronaspades.py"
        DESTINATION bin
        COMPONENT runtime)      
install(PROGRAMS "${CMAKE_CURRENT_SOURCE_DIR}/../truspades.py"
        DESTINATION bin
        COMPONENT runtime)

install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../spades_init.py"
        DESTINATION bin
        COMPONENT runtime)
# FIXME: Should we just configure spades_init instead?
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../VERSION"
        DESTINATION share/spades
        COMPONENT runtime)
# Test datasets
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/../test_dataset"
        DESTINATION share/spades)
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/../test_dataset_truspades"
        DESTINATION share/spades)
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/../test_dataset_plasmid"
        DESTINATION share/spades)
#biosyntheticSPAdes default HMM profiles
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/../biosynthetic_spades_hmms"
        DESTINATION share/spades)
#coronaSPAdes default HMM profiles
install(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/../coronaspades_hmms"
        DESTINATION share/spades)
# manual, LICENSE, and GPLv2
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../manual.html"
        DESTINATION share/spades
        COMPONENT runtime)
install(FILES "${README_MD_PATH}"
        DESTINATION share/spades
        COMPONENT runtime)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../truspades_manual.html"
        DESTINATION share/spades
        COMPONENT runtime)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../rnaspades_manual.html"
        DESTINATION share/spades
        COMPONENT runtime)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../LICENSE"
        DESTINATION share/spades
        COMPONENT runtime)
install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../GPLv2.txt"
        DESTINATION share/spades
        COMPONENT runtime)

# Random stuff
include(CMakeListsInternal.txt)

# Packaging
include(pack)

# Workaround for poor CLion users
file(GLOB_RECURSE clion_all_headers
  ${CMAKE_SOURCE_DIR}/*.hpp ${CMAKE_SOURCE_DIR}/*.h)
add_custom_target(all_clion SOURCES ${clion_all_headers})

=== assembler/ext/src/getopt_pp/CMakeLists.txt ===
project(getopt_pp CXX)

add_library(getopt_pp STATIC
            getopt_pp.cpp)

=== assembler/ext/src/hmmer/CMakeLists.txt ===
project(hmmer C)

set(HMMER_DATE "July 2016")
set(HMMER_COPYRIGHT "Copyright (C) 2016 Howard Hughes Medical Institute.")
set(HMMER_LICENSE "Freely distributed under the BSD open source license.")
set(HMMER_VERSION "3.1b3")
set(HMMER_URL "http://hmmer.org/")
set(HMMER_SADIR "libdivsufsort")

set(HMMER_MAIN_SRC_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)
set(HMMER_BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR})
set(HMMER_TOOLS_BINARY_DIR ${HMMER_BINARY_DIR}/bin)
set(HMMER_BUILT_INCLUDE_DIR ${HMMER_BINARY_DIR}/include)

include(CheckIncludeFiles)

check_include_files(endian.h HAVE_FEATURES_H)
check_include_files(inttypes.h HAVE_INTTYPES_H)
check_include_files(stdint.h HAVE_STDINT_H)
check_include_files(unistd.h HAVE_UNISTD_H)
check_include_files(strings.h HAVE_STRINGS_H)
check_include_files(sys/types.h HAVE_SYS_TYPES_H)
check_include_files(sys/param.h HAVE_SYS_PARAM_H)
check_include_files(sys/sysctl.h HAVE_SYS_SYSCTL_H)

check_include_files(emmintrin.h HAVE_SSE2)
check_include_files(pmmintrin.h HAVE_SSE3)
check_include_files(xmmintrin.h HAVE_SSE)
if (HAVE_SSE2)
  set(HAVE_SSE2_CAST 1)
  set(p7_IMPL_SSE 1)
endif()

find_package(Threads)
if (CMAKE_USE_PTHREADS_INIT)
  set(HAVE_PTHREAD 1)
  set(HMMER_THREADS 1)
endif()

set(eslLIBRARY 1)

include(CheckFunctionExists)
check_function_exists(fstat HAVE_FSTAT)
check_function_exists(getcwd HAVE_GETCWD)
check_function_exists(getpid HAVE_GETPID)
check_function_exists(mkstemp HAVE_MKSTEMP)
check_function_exists(popen HAVE_POPEN)
check_function_exists(stat HAVE_STAT)
check_function_exists(strcasecmp HAVE_STRCASECMP)
check_function_exists(sysconf HAVE_SYSCONF)
check_function_exists(sysctl HAVE_SYSCTL)
check_function_exists(times HAVE_TIMES)

configure_file("${HMMER_MAIN_SRC_DIR}/p7_config.h.cmake"
               "${HMMER_BUILT_INCLUDE_DIR}/p7_config.h")

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(hmmer_src
  src/build.c src/cachedb.c src/emit.c src/errors.c src/evalues.c src/eweight.c
  src/generic_decoding.c src/generic_fwdback.c src/generic_fwdback_chk.c
  src/generic_fwdback_banded.c src/generic_null2.c src/generic_msv.c
  src/generic_optacc.c src/generic_stotrace.c src/generic_viterbi.c
  src/generic_vtrace.c src/h2_io.c src/heatmap.c src/hmmlogo.c src/hmmdmstr.c
  src/hmmdwrkr.c src/hmmdutils.c src/hmmer.c src/logsum.c src/modelconfig.c
  src/modelstats.c src/mpisupport.c src/seqmodel.c src/tracealign.c
  src/p7_alidisplay.c src/p7_bg.c src/p7_builder.c src/p7_domaindef.c
  src/p7_gbands.c src/p7_gmx.c src/p7_gmxb.c src/p7_gmxchk.c
  src/p7_hmm.c src/p7_hmmcache.c src/p7_hmmfile.c src/p7_hmmwindow.c
  src/p7_null3.c src/p7_pipeline.c src/p7_prior.c src/p7_profile.c
  src/p7_spensemble.c src/p7_tophits.c src/p7_trace.c src/p7_scoredata.c
  src/hmmpgmd2msa.c src/fm_alphabet.c src/fm_general.c src/fm_sse.c src/fm_ssv.c)

if (HAVE_SSE2)
  set(hmmer_sse_src
    src/impl_sse/decoding.c src/impl_sse/fwdback.c src/impl_sse/io.c src/impl_sse/ssvfilter.c
    src/impl_sse/msvfilter.c src/impl_sse/null2.c src/impl_sse/optacc.c src/impl_sse/stotrace.c
    src/impl_sse/vitfilter.c src/impl_sse/p7_omx.c src/impl_sse/p7_oprofile.c src/impl_sse/mpi.c)
  set(hmmer_src ${hmmer_src} ${hmmer_sse_src})
endif()

add_library(hmmer STATIC ${hmmer_src})
target_include_directories(hmmer SYSTEM PUBLIC ${HMMER_BUILT_INCLUDE_DIR} ${HMMER_MAIN_SRC_DIR})
target_link_libraries(hmmer easel m)

message("${easel_includes}")

=== assembler/ext/src/mimalloc/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(libmimalloc C CXX)

set(CMAKE_C_STANDARD 11)
set(CMAKE_CXX_STANDARD 17)

option(MI_SECURE            "Use full security mitigations (like guard pages, allocation randomization, double-free mitigation, and free-list corruption detection)" OFF)
option(MI_DEBUG_FULL        "Use full internal heap invariant checking in DEBUG mode (expensive)" OFF)
option(MI_PADDING           "Enable padding to detect heap block overflow (used only in DEBUG mode)" ON)
option(MI_OVERRIDE          "Override the standard malloc interface (e.g. define entry points for malloc() etc)" ON)
option(MI_OVERRIDE_GLIBC    "Override strong glibc functions (might break static build)" ON)
option(MI_OVERRIDE_WRAP     "Use linker wrap functionality to override strong glibc functions" OFF)
option(MI_XMALLOC           "Enable abort() call on memory allocation failure by default" OFF)
option(MI_SHOW_ERRORS       "Show error and warning messages by default (only enabled by default in DEBUG mode)" OFF)
option(MI_USE_CXX           "Use the C++ compiler to compile the library (instead of the C compiler)" OFF)
option(MI_SEE_ASM           "Generate assembly files" OFF)
option(MI_INTERPOSE         "Use interpose to override standard malloc on macOS" ON)
option(MI_OSX_ZONE          "Use malloc zone to override standard malloc on macOS" OFF) # enables interpose as well
option(MI_LOCAL_DYNAMIC_TLS "Use slightly slower, dlopen-compatible TLS mechanism (Unix)" OFF)
option(MI_BUILD_SHARED      "Build shared library" ON)
option(MI_BUILD_STATIC      "Build static library" ON)
option(MI_BUILD_OBJECT      "Build object library" ON)
option(MI_BUILD_TESTS       "Build test executables" ON)
option(MI_DEBUG_TSAN        "Build with thread sanitizer (needs clang)" OFF)
option(MI_DEBUG_UBSAN       "Build with undefined-behavior sanitizer (needs clang++)" OFF)
option(MI_CHECK_FULL        "Use full internal invariant checking in DEBUG mode (deprecated, use MI_DEBUG_FULL instead)" OFF)

include("cmake/mimalloc-config-version.cmake")

set(mi_sources
    src/stats.c
    src/random.c
    src/os.c
    src/bitmap.c
    src/arena.c
    src/region.c
    src/segment.c
    src/page.c
    src/alloc.c
    src/alloc-aligned.c
    src/alloc-posix.c
    src/heap.c
    src/options.c
    src/init.c)

# -----------------------------------------------------------------------------
# Converience: set default build type depending on the build directory
# -----------------------------------------------------------------------------

if (NOT CMAKE_BUILD_TYPE)
  if ("${CMAKE_BINARY_DIR}" MATCHES ".*(D|d)ebug$" OR  MI_DEBUG_FULL MATCHES "ON")
    message(STATUS "No build type selected, default to: Debug")
    set(CMAKE_BUILD_TYPE "Debug")
  else()
    message(STATUS "No build type selected, default to: Release")
    set(CMAKE_BUILD_TYPE "Release")
  endif()
endif()

if("${CMAKE_BINARY_DIR}" MATCHES ".*(S|s)ecure$")
  message(STATUS "Default to secure build")
  set(MI_SECURE "ON")
endif()

# -----------------------------------------------------------------------------
# Process options
# -----------------------------------------------------------------------------

if(CMAKE_C_COMPILER_ID MATCHES "MSVC|Intel")
  set(MI_USE_CXX "ON")
endif()

if(MI_OVERRIDE MATCHES "ON")
  message(STATUS "Override standard malloc (MI_OVERRIDE=ON)")
  if(APPLE)
    if(MI_OSX_ZONE MATCHES "ON")
      # use zone's on macOS
      message(STATUS "  Use malloc zone to override malloc (MI_OSX_ZONE=ON)")
      list(APPEND mi_sources src/alloc-override-osx.c)
      list(APPEND mi_defines MI_OSX_ZONE=1)
      if(NOT MI_INTERPOSE MATCHES "ON")
        message(STATUS "  (enabling INTERPOSE as well since zone's require this)")
        set(MI_INTERPOSE "ON")
      endif()
    endif()
    if(MI_INTERPOSE MATCHES "ON")
      # use interpose on macOS
      message(STATUS "  Use interpose to override malloc (MI_INTERPOSE=ON)")
      list(APPEND mi_defines MI_INTERPOSE)
    endif()
  endif()
endif()

if(MI_SECURE MATCHES "ON")
  message(STATUS "Set full secure build (MI_SECURE=ON)")
  list(APPEND mi_defines MI_SECURE=4)
endif()

if(MI_SEE_ASM MATCHES "ON")
  message(STATUS "Generate assembly listings (MI_SEE_ASM=ON)")
  list(APPEND mi_cflags -save-temps)
endif()

if(MI_CHECK_FULL MATCHES "ON")
  message(STATUS "The MI_CHECK_FULL option is deprecated, use MI_DEBUG_FULL instead")
  set(MI_DEBUG_FULL "ON")
endif()

if(MI_DEBUG_FULL MATCHES "ON")
  message(STATUS "Set debug level to full internal invariant checking (MI_DEBUG_FULL=ON)")
  list(APPEND mi_defines MI_DEBUG=3)   # full invariant checking
endif()

if(MI_PADDING MATCHES "OFF")
  message(STATUS "Disable padding of heap blocks in debug mode (MI_PADDING=OFF)")
  list(APPEND mi_defines MI_PADDING=0)
endif()

if(MI_XMALLOC MATCHES "ON")
  message(STATUS "Enable abort() calls on memory allocation failure (MI_XMALLOC=ON)")
  list(APPEND mi_defines MI_XMALLOC=1)
endif()

if(MI_SHOW_ERRORS MATCHES "ON")
  message(STATUS "Enable printing of error and warning messages by default (MI_SHOW_ERRORS=ON)")
  list(APPEND mi_defines MI_SHOW_ERRORS=1)
endif()

if(MI_DEBUG_TSAN MATCHES "ON") 
  if(CMAKE_C_COMPILER_ID MATCHES "Clang")
    message(STATUS "Build with thread sanitizer (MI_DEBUG_TSAN=ON)")
    list(APPEND mi_defines MI_TSAN=1)
    list(APPEND mi_cflags -fsanitize=thread -g -O1)
    list(APPEND CMAKE_EXE_LINKER_FLAGS -fsanitize=thread)
  else()
    message(WARNING "Can only use thread sanitizer with clang (MI_DEBUG_TSAN=ON but ignored)")    
  endif()  
endif()

if(MI_DEBUG_UBSAN MATCHES "ON") 
  if(CMAKE_BUILD_TYPE MATCHES "Debug")    
    if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
      message(STATUS "Build with undefined-behavior sanitizer (MI_DEBUG_UBSAN=ON)")
      list(APPEND mi_cflags -fsanitize=undefined -g)
      list(APPEND CMAKE_EXE_LINKER_FLAGS -fsanitize=undefined)
      if (MI_USE_CXX MATCHES "OFF")
        message(STATUS "(switch to use C++ due to MI_DEBUG_UBSAN)")
        set(MI_USE_CXX "ON")
      endif()
    else()
      message(WARNING "Can only use undefined-behavior sanitizer with clang++ (MI_DEBUG_UBSAN=ON but ignored)")    
    endif()  
  else()
    message(WARNING "Can only use thread sanitizer with a debug build (CMAKE_BUILD_TYPE=${CMAKE_BUILD_TYPE})")    
  endif()
endif()

if(MI_USE_CXX MATCHES "ON")
  message(STATUS "Use the C++ compiler to compile (MI_USE_CXX=ON)")
  set_source_files_properties(${mi_sources} PROPERTIES LANGUAGE CXX )
  set_source_files_properties(src/static.c test/test-api.c test/test-stress PROPERTIES LANGUAGE CXX )
  if(CMAKE_CXX_COMPILER_ID MATCHES "AppleClang|Clang")
    list(APPEND mi_cflags -Wno-deprecated)
  endif()
  if(CMAKE_CXX_COMPILER_ID MATCHES "Intel")
    list(APPEND mi_cflags -Kc++)
  endif()
endif()

# Compiler flags
if(CMAKE_C_COMPILER_ID MATCHES "AppleClang|Clang|GNU")
  list(APPEND mi_cflags -Wall -Wextra -Wno-unknown-pragmas -fvisibility=hidden)
  if(CMAKE_C_COMPILER_ID MATCHES "GNU")
    list(APPEND mi_cflags -Wno-invalid-memory-model)
  endif()
endif()

if(CMAKE_C_COMPILER_ID MATCHES "Intel")
  list(APPEND mi_cflags -Wall -fvisibility=hidden)
endif()

if(CMAKE_C_COMPILER_ID MATCHES "AppleClang|Clang|GNU|Intel" AND NOT CMAKE_SYSTEM_NAME MATCHES "Haiku")
  if(MI_LOCAL_DYNAMIC_TLS MATCHES "ON")
    list(APPEND mi_cflags -ftls-model=local-dynamic)
  else()
    list(APPEND mi_cflags -ftls-model=initial-exec)
  endif()
endif()

# Architecture flags
if(${CMAKE_HOST_SYSTEM_PROCESSOR} MATCHES "arm")
    list(APPEND mi_cflags -march=native)
endif()

# extra needed libraries
if(WIN32)
  list(APPEND mi_libraries psapi shell32 user32 advapi32 bcrypt)
else()
  if(NOT ${CMAKE_C_COMPILER} MATCHES "android")
    list(APPEND mi_libraries pthread)
    find_library(LIBRT rt)
    if(LIBRT)
      list(APPEND mi_libraries ${LIBRT})
    endif()
  endif()
endif()

# -----------------------------------------------------------------------------
# Install and output names
# -----------------------------------------------------------------------------

set(mi_install_dir "${CMAKE_INSTALL_PREFIX}/lib/mimalloc-${mi_version}")
if(MI_SECURE MATCHES "ON")
  set(mi_basename "mimalloc-secure")
else()
  set(mi_basename "mimalloc")
endif()
string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LC)
if(NOT(CMAKE_BUILD_TYPE_LC MATCHES "^(release|relwithdebinfo|minsizerel)$"))
  set(mi_basename "${mi_basename}-${CMAKE_BUILD_TYPE_LC}") #append build type (e.g. -debug) if not a release version
endif()
if(MI_BUILD_SHARED)
  list(APPEND mi_build_targets "shared")
endif()
if(MI_BUILD_STATIC)
  list(APPEND mi_build_targets "static")
endif()
if(MI_BUILD_OBJECT)
  list(APPEND mi_build_targets "object")
endif()
if(MI_BUILD_TESTS)
  list(APPEND mi_build_targets "tests")
endif()
message(STATUS "")
message(STATUS "Library base name: ${mi_basename}")
message(STATUS "Build type       : ${CMAKE_BUILD_TYPE_LC}")
if(MI_USE_CXX MATCHES "ON")
  message(STATUS "Compiler         : ${CMAKE_CXX_COMPILER}")
else()
  message(STATUS "Compiler         : ${CMAKE_C_COMPILER}")
endif()
message(STATUS "Install directory: ${mi_install_dir}")
message(STATUS "Build targets    : ${mi_build_targets}")
message(STATUS "")

# -----------------------------------------------------------------------------
# Main targets
# -----------------------------------------------------------------------------

# shared library
if(MI_BUILD_SHARED)
  add_library(mimalloc SHARED ${mi_sources})
  set_target_properties(mimalloc PROPERTIES VERSION ${mi_version} OUTPUT_NAME ${mi_basename} )
  target_compile_definitions(mimalloc PRIVATE ${mi_defines} MI_SHARED_LIB MI_SHARED_LIB_EXPORT)
  target_compile_options(mimalloc PRIVATE ${mi_cflags})
  target_link_libraries(mimalloc PUBLIC ${mi_libraries})
  target_include_directories(mimalloc PUBLIC
      $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
      $<INSTALL_INTERFACE:${mi_install_dir}/include>
  )
  if(WIN32)
    # On windows copy the mimalloc redirection dll too.
    target_link_libraries(mimalloc PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}/bin/mimalloc-redirect.lib)
    add_custom_command(TARGET mimalloc POST_BUILD
      COMMAND "${CMAKE_COMMAND}" -E copy "${CMAKE_CURRENT_SOURCE_DIR}/bin/mimalloc-redirect.dll" $<TARGET_FILE_DIR:mimalloc>
      COMMENT "Copy mimalloc-redirect.dll to output directory")
  endif()

  install(TARGETS mimalloc EXPORT mimalloc DESTINATION ${mi_install_dir} LIBRARY)
  install(EXPORT mimalloc DESTINATION ${mi_install_dir}/cmake)
endif()

# static library
if (MI_BUILD_STATIC)
  add_library(mimalloc-static STATIC ${mi_sources})
  set_property(TARGET mimalloc-static PROPERTY POSITION_INDEPENDENT_CODE ON)
  target_compile_definitions(mimalloc-static PRIVATE ${mi_defines} MI_STATIC_LIB)
  target_compile_options(mimalloc-static PRIVATE ${mi_cflags})
  target_link_libraries(mimalloc-static PUBLIC ${mi_libraries})
  target_include_directories(mimalloc-static PUBLIC
      $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
      $<INSTALL_INTERFACE:${mi_install_dir}/include>
  )
  if(WIN32)
    # When building both static and shared libraries on Windows, a static library should use a
    # different output name to avoid the conflict with the import library of a shared one.
    string(REPLACE "mimalloc" "mimalloc-static" mi_output_name ${mi_basename})
    set_target_properties(mimalloc-static PROPERTIES OUTPUT_NAME ${mi_output_name})
  else()
    set_target_properties(mimalloc-static PROPERTIES OUTPUT_NAME ${mi_basename})
  endif()

  install(TARGETS mimalloc-static EXPORT mimalloc DESTINATION ${mi_install_dir})
endif()

# install include files
install(FILES include/mimalloc.h DESTINATION ${mi_install_dir}/include)
install(FILES include/mimalloc-override.h DESTINATION ${mi_install_dir}/include)
install(FILES include/mimalloc-new-delete.h DESTINATION ${mi_install_dir}/include)
install(FILES cmake/mimalloc-config.cmake DESTINATION ${mi_install_dir}/cmake)
install(FILES cmake/mimalloc-config-version.cmake DESTINATION ${mi_install_dir}/cmake)

=== assembler/ext/src/samtools/CMakeLists.txt ===
# -*- cmake -*-

############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(samtools C)

add_definitions(-D_FILE_OFFSET_BITS=64 -D_USE_KNETFILE -DMD5SUM_MAIN -D_CURSES_LIB=1)

add_library (samtools
  kstring.c
  bam_aux.c
  bam.c
  bam_import.c
  sam.c
  bam_index.c
  bam_pileup.c
  bam_lpileup.c
  bam_md.c
  razf.c
  faidx.c
  bedidx.c
  bam_sort.c
  sam_header.c
  bam_reheader.c
  kprobaln.c
  bam_cat.c)
target_link_libraries(samtools BamTools)

=== assembler/ext/src/teamcity_gtest/CMakeLists.txt ===
############################################################################
# Copyright (c) 2019 Saint Petersburg State University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(teamcity_gtest CXX)

add_library(teamcity_gtest STATIC
            teamcity_gtest.cpp
            teamcity_messages.cpp)
target_link_libraries(teamcity_gtest gtest)

=== assembler/src/common/assembly_graph/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(assembly_graph CXX)

add_library(assembly_graph STATIC
            core/id_distributor.cpp
            components/connected_component.cpp
            paths/bidirectional_path.cpp
            paths/bidirectional_path_io/io_support.cpp
            paths/bidirectional_path_io/bidirectional_path_output.cpp
            graph_support/scaff_supplementary.cpp graph_support/coverage_uniformity_analyzer.cpp
            ../modules/alignment/edge_index_refiller.cpp)

target_link_libraries(assembly_graph utils llvm-support)

=== assembler/src/common/hmm/CMakeLists.txt ===
############################################################################
# Copyright (c) 2018 Saint Petersburg State University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(hmmercpp CXX)

add_library(hmmercpp STATIC
            hmmfile.cpp hmmmatcher.cpp)
target_link_libraries(hmmercpp easel hmmer)

=== assembler/src/common/modules/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(modules CXX)

add_library(modules STATIC
            chromosome_remover.cpp
            genome_consistance_checker.cpp
            alignment/gap_info.cpp
            alignment/bwa_index.cpp
            alignment/long_read_mapper.cpp
            alignment/sequence_mapper.cpp
            alignment/sequence_mapper_notifier.cpp
            alignment/pacbio/gap_filler.cpp
            alignment/pacbio/gap_dijkstra.cpp 
            alignment/pacbio/g_aligner.cpp 
            alignment/pacbio/g_aligner.cpp)

target_link_libraries(modules sequence bwa assembly_graph)

=== assembler/src/common/paired_info/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(paired_info CXX)

add_library(paired_info STATIC
        distance_estimation.cpp weighted_distance_estimation.cpp smoothing_distance_estimation.cpp)

=== assembler/src/common/pipeline/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(pipeline CXX)

add_library(pipeline STATIC
            config_struct.cpp
            graph_pack.cpp
            library.cpp
            library_data.cpp
            stage.cpp)

target_link_libraries(pipeline binary_io path_extend input llvm-support)

=== assembler/src/common/sequence/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(sequence CXX)

add_library(sequence STATIC
            sequence_tools.cpp)

target_link_libraries(sequence edlib)

=== debian/changelog ===
spades (3.15.5+dfsg-7) unstable; urgency=medium

  * Replace distutils which is removed in Python3.12
    Closes: #1061846
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)
  * Depends: s/python3-distutils/python3-packaging/

 -- Andreas Tille <tille@debian.org>  Fri, 02 Feb 2024 09:16:42 +0100

spades (3.15.5+dfsg-6) unstable; urgency=medium

  * d/rules: disable lto builds.
    Upstream is aware that there is a problem with lto appllied on spades,
    and this seems to be caused by a lingering compiler bug. (Closes: #1015668)

 -- Étienne Mollier <emollier@debian.org>  Sun, 03 Dec 2023 14:52:02 +0100

spades (3.15.5+dfsg-5) unstable; urgency=medium

  [ Heinrich Schuchardt ]
  * Add missing libzstd-dev build dependency
    Closes: #1052315 (LP: #2036726)

  [ Andreas Tille ]
  * Standards-Version: 4.6.2 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 21 Sep 2023 13:22:20 +0200

spades (3.15.5+dfsg-4) unstable; urgency=medium

  * d/control: spades is AMD64 only, as per upstream. Closes: #976523
  * d/patches: mark many as not needing forwarding

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 09 Aug 2023 12:45:25 +0200

spades (3.15.5+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Add fix-gcc13.patch to fix gcc-13 build issues. (Closes: #1037863)

 -- Bo YU <tsu.yubo@gmail.com>  Thu, 20 Jul 2023 21:38:50 +0800

spades (3.15.5+dfsg-2) unstable; urgency=medium

  * d/control: add missing build-deps following llvm reorganization.
    (Closes: #1022309)
  * yaml_load.patch: update to fix new pyyaml.load calls. (Closes: #1022086)
  * d/copyright: bump copyright year.

 -- Étienne Mollier <emollier@debian.org>  Sun, 23 Oct 2022 16:59:13 +0200

spades (3.15.5+dfsg-1) unstable; urgency=medium

  * New upstream version 3.15.5+dfsg
  * d/patches/:
    + fix-privacy-breaches.patch: update badges list.
    + python3.patch: refresh.
    + 0003_accept-system-bwa.patch: unfuzz.
    + yaml_load.patch: unfuzz.
  * d/m/coronaspades.1.adoc: add manual page for coronaspades.
  * d/links: create a link for coronaspades.py manual.
  * d/t/run-upstreams-tests: add self tests for plasmidspades and coronaspades.
    Also, the truspades command is deprecated, so don't make it's self-test
    failure critical.
  * d/salsa-ci.yml: disable run for i386 architecture.
  * d/NEWS: forward deprecation of truspades with notice it may not work well.

 -- Étienne Mollier <emollier@debian.org>  Mon, 01 Aug 2022 21:11:59 +0200

spades (3.15.4+dfsg-3) unstable; urgency=medium

  * d/t/run-upstreams-tests: make tests a bit more verbose.
  * Adjust 0003_accept-system-bwa.patch: import support functions.
    (Closes: #1011968)
  * Refresh yaml_load.patch.
  * Remove patches not part of d/p/series anymore.
  * Add fix-privacy-breaches.patch: remove build status badges.
  * Add typos.patch: fix typos caught by lintian.
  * d/copyright: reorder to match globbing properly.
  * d/s/lintian-overrides: unclear why html files are missing source code.
  * Standards-Version: 4.6.1 (routine-update)

 -- Étienne Mollier <emollier@debian.org>  Sat, 25 Jun 2022 17:41:51 +0200

=== debian/control ===
Source: spades
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Sascha Steinbiss <satta@debian.org>,
           Michael R. Crusoe <crusoe@debian.org>,
           Alexandre Mestiashvili <mestia@debian.org>,
           Étienne Mollier <emollier@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-sequence-python3,
               clang-format,
               clang-tidy,
               clang-tools,
               cmake,
               python3-all,
               zlib1g-dev,
               libbz2-dev,
               libbam-dev,
               libbamtools-dev,
               libc++-dev,
               libhts-dev,
               libnlopt-dev,
               libnlopt-cxx-dev,
               libssw-dev,
               libzstd-dev,
               llvm-dev,
               python3-yaml,
               python3-joblib,
               asciidoctor,
               bwa,
               libbwa-dev,
               lynx
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/spades
Vcs-Git: https://salsa.debian.org/med-team/spades.git
Homepage: http://cab.spbu.ru/software/spades/
Rules-Requires-Root: no

Package: spades
Architecture: amd64
Depends: ${shlibs:Depends},
         ${python3:Depends},
         ${misc:Depends},
         python3,
         python3-joblib,
         python3-packaging,
         python3-yaml,
         bwa,
         bamtools,
         samtools
Description: genome assembler for single-cell and isolates data sets
 The SPAdes – St. Petersburg genome assembler is intended for both
 standard isolates and single-cell MDA bacteria assemblies.  It works
 with Illumina or IonTorrent reads and is capable of providing hybrid
 assemblies using PacBio and Sanger reads. You can also provide
 additional contigs that will be used as long reads.
 .
 This package provides the following additional pipelines:
  * metaSPAdes – a pipeline for metagenomic data sets
  * plasmidSPAdes – a pipeline for extracting and assembling plasmids
    from WGS data sets
  * metaplasmidSPAdes – a pipeline for extracting and assembling
    plasmids from metagenomic data sets
  * rnaSPAdes – a de novo transcriptome assembler from RNA-Seq data
  * truSPAdes – a module for TruSeq barcode assembly
  * biosyntheticSPAdes – a module for biosynthetic gene cluster
    assembly with paired-end reads
 .
 SPAdes provides several stand-alone binaries with relatively simple
 command-line interface: k-mer counting (spades-kmercounter), assembly
 graph construction (spades-gbuilder) and long read to graph aligner
 (spades-gmapper).

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

include /usr/share/dpkg/default.mk

mandir     := $(CURDIR)/debian/man
debfolder  := $(CURDIR)/debian

export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
export LC_ALL = C

%:
	dh $@ --sourcedirectory=assembler/src --buildsystem=cmake

override_dh_clean:
	dh_clean -X.orig

override_dh_auto_clean:
	dh_auto_clean
	find . -name "*.pyc" -delete
	rm -rf $(debfolder)/man_src/*.html $(debfolder)/man_src/*.?
	rm -rf $(mandir)

override_dh_auto_configure:
	dh_auto_configure -- -DBoost_NO_BOOST_CMAKE=TRUE

override_dh_auto_build:
	dh_auto_build -- all debruijn_test include_test

execute_after_dh_auto_install:
	# Use Debian-packaged yaml module
	find debian/spades \
		-type f \
		-exec sed -i 's/pyyaml[2|3]/yaml/' {} +

	mkdir -p debian/$(DEB_SOURCE)/usr/libexec/spades/
	mv debian/$(DEB_SOURCE)/usr/bin/* debian/$(DEB_SOURCE)/usr/libexec/spades/

	rm -f debian/$(DEB_SOURCE)/usr/share/spades/*.html
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/manual.md
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/GPLv2.txt
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/README.md
	rm -f debian/$(DEB_SOURCE)/usr/share/spades/LICENSE

override_dh_installman:
	mkdir -p $(mandir)
	asciidoctor -a docdate='' -b manpage $(debfolder)/man_src/*.adoc
	cp $(debfolder)/man_src/*.? $(mandir)
	dh_installman

override_dh_installchangelogs:
	LANG="C" LANGUAGE="en_US:en" LC_ALL=C.UTF-8 lynx -dump assembler/changelog.html > changelog
	dh_installchangelogs changelog
	rm changelog

## spades 4.0.0%2Breally3.15.5%2Bdfsg

=== assembler/src/projects/CMakeLists.txt ===
############################################################################
# Copyright (c) 2015 Saint Petersburg State University
# Copyright (c) 2011-2014 Saint Petersburg Academic University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

add_subdirectory(spades)
add_subdirectory(hammer)
add_subdirectory(ionhammer)
add_subdirectory(corrector)
add_subdirectory(scaffold_correction)
add_subdirectory(kmercount)
add_subdirectory(bin_converter)
add_subdirectory(gbuilder)
add_subdirectory(gmapper)
add_subdirectory(unitig_coverage)
add_subdirectory(spaligner)
add_subdirectory(gsimplifier)
add_subdirectory(cds_subgraphs)
add_subdirectory(bin_analysis)

=== assembler/src/projects/kmercount/CMakeLists.txt ===
############################################################################
# Copyright (c) 2016 Saint Petersburg State University
# All Rights Reserved
# See file LICENSE for details.
############################################################################

project(spades-kmercount CXX)

include_directories(${CMAKE_CURRENT_SOURCE_DIR})


add_executable(spades-kmercount
               main.cpp)

add_executable(spades-read-filter
               read_filter.cpp)

add_executable(spades-kmer-estimating
               kmer_estimating.cpp)

target_link_libraries(spades-kmercount common_modules ${COMMON_LIBRARIES})
target_link_libraries(spades-read-filter common_modules ${COMMON_LIBRARIES})
target_link_libraries(spades-kmer-estimating common_modules ${COMMON_LIBRARIES})


if (SPADES_STATIC_BUILD)
  set_target_properties(spades-kmercount PROPERTIES LINK_SEARCH_END_STATIC 1)
  set_target_properties(spades-read-filter PROPERTIES LINK_SEARCH_END_STATIC 1)
endif()

install(TARGETS spades-kmercount
        DESTINATION bin
        COMPONENT runtime)

install(TARGETS spades-read-filter
        DESTINATION bin
        COMPONENT runtime)

install(TARGETS spades-kmer-estimating
        DESTINATION bin
        COMPONENT runtime)
